﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTabs;
using Infragistics.Win;
using Infragistics.Win.UltraWinDock;

namespace _102949
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraDockManager1_MouseEnterElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            DockableControlPane pane = null;
            if (FlyoutPane(e.Element, ref pane))
            {
                timer1.Enabled = false;
                timer1.Enabled = true;
                timer1.Tag = pane;
            }
        }

        private void ultraDockManager1_MouseLeaveElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            if (e.Element is TabItemUIElement)
            {
                timer1.Enabled = false;
                timer1.Tag = null;
            }
        }

        private bool FlyoutPane(UIElement element, ref DockableControlPane pane)
        {
            if(element is TabItemUIElement )
            {
                pane = (DockableControlPane)((TabItemUIElement)element).TabItem;
                return ((!pane.Pinned) && (!pane.IsFlyoutPaneDisplayed));
            }
            else
                return false;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
           Binding b =  numericUpDown1.DataBindings.Add("Value", timer1,"Interval");
           b.ControlUpdateMode = ControlUpdateMode.OnPropertyChanged;
           b.DataSourceUpdateMode = DataSourceUpdateMode.OnPropertyChanged;
           
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            DockableControlPane pane = (DockableControlPane)((Timer)sender).Tag;
            if (pane != null)
            {
                pane.Flyout(true, false);
                ((Timer)sender).Enabled = false;
            }
        }
    }
}
